// Generated by CoffeeScript 1.12.7
ez5.IUCNUtil = (function() {
  function IUCNUtil() {}

  IUCNUtil.ENDPOINT_SPECIES = "/species/";

  IUCNUtil.ENDPOINT_SPECIES_ID = "/species/id/";

  IUCNUtil.ENDPOINT_SPECIES_PAGE = "/species/page/";

  IUCNUtil.LINK_FIELD_SEPARATOR = ":__link:";

  IUCNUtil.getFieldType = function() {
    return "custom:base.custom-data-type-iucn.iucn";
  };

  IUCNUtil.searchBySpecies = function(species, apiSettings) {
    var url;
    if (!apiSettings) {
      apiSettings = ez5.IUCNUtil.getApiSettings();
    }
    url = apiSettings.api_url + ez5.IUCNUtil.ENDPOINT_SPECIES + encodeURIComponent(species) + "?token=" + apiSettings.api_token;
    return ez5.IUCNUtil.get(url);
  };

  IUCNUtil.searchBySpeciesId = function(id, apiSettings) {
    var url;
    if (!apiSettings) {
      apiSettings = ez5.IUCNUtil.getApiSettings();
    }
    url = apiSettings.api_url + ez5.IUCNUtil.ENDPOINT_SPECIES_ID + id + "?token=" + apiSettings.api_token;
    return ez5.IUCNUtil.get(url);
  };

  IUCNUtil.fetchAllSpecies = function(apiSettings) {
    var data, deferred, fetchPage;
    if (!apiSettings) {
      apiSettings = ez5.IUCNUtil.getApiSettings();
    }
    data = {
      objects: []
    };
    deferred = new CUI.Deferred();
    fetchPage = function(page) {
      var url;
      if (page == null) {
        page = 0;
      }
      url = apiSettings.api_url + ez5.IUCNUtil.ENDPOINT_SPECIES_PAGE + page + "?token=" + apiSettings.api_token;
      return ez5.IUCNUtil.get(url).done((function(_this) {
        return function(response) {
          if (!response || response.message) {
            return deferred.resolve(response);
          }
          if (response.count > 0) {
            data.objects = data.objects.concat(response.result);
            page++;
            return fetchPage(page);
          } else {
            return deferred.resolve(data);
          }
        };
      })(this)).fail(deferred.reject);
    };
    fetchPage();
    return deferred.promise();
  };

  IUCNUtil.get = function(url) {
    var xhr;
    xhr = new CUI.XHR({
      method: "GET",
      url: url
    });
    return xhr.start();
  };

  IUCNUtil.setObjectData = function(object, data) {
    var ref;
    if (CUI.util.isEmpty(data)) {
      delete object.idTaxon;
      delete object.scientificName;
      delete object.mainCommonName;
      delete object.category;
      delete object.redList;
      delete object.unclear;
      return;
    }
    object.unclear = false;
    object.redList = false;
    if (CUI.util.isArray(data)) {
      if (data.length > 1) {
        object.unclear = true;
      }
      data = data[0];
    }
    if (!data.taxonid) {
      object.scientificName = data.scientific_name;
      return object;
    }
    if (!object.unclear) {
      object.redList = (ref = data.category) === "EX" || ref === "EW" || ref === "CR" || ref === "EN" || ref === "VU";
    }
    object.idTaxon = "" + data.taxonid;
    object.scientificName = data.scientific_name || "";
    object.mainCommonName = data.main_common_name || "";
    object.category = data.category;
    return object;
  };

  IUCNUtil.isEqual = function(objectOne, objectTwo) {
    var i, key, len, ref;
    ref = ["idTaxon", "scientificName", "mainCommonName", "category", "redList", "unclear"];
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      if (!CUI.util.isEqual(objectOne[key], objectTwo[key])) {
        return false;
      }
    }
    return true;
  };

  IUCNUtil.getSaveData = function(data) {
    var saveData;
    saveData = {
      idTaxon: data.idTaxon,
      scientificName: data.scientificName,
      mainCommonName: data.mainCommonName,
      category: data.category,
      redList: data.redList,
      unclear: data.unclear,
      _fulltext: {
        text: data.scientificName + " " + data.mainCommonName,
        string: "" + data.idTaxon
      },
      _standard: {
        text: data.scientificName
      }
    };
    return saveData;
  };

  IUCNUtil.getApiSettings = function() {
    return ez5.session.getBaseConfig("plugin", "custom-data-type-iucn").iucn_api_settings;
  };

  IUCNUtil.getSettings = function() {
    return ez5.session.getBaseConfig("plugin", "custom-data-type-iucn").iucn_settings;
  };

  return IUCNUtil;

})();
